﻿using ProtoSF.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace ProtoSF.Controllers
{
    public class GridController : Controller
    {
        List<Person> model = WholeModel.PersonDB;
        //
        // GET: /Grid/
        public ActionResult Index()
        {
            return View();
        }



        //PROVIDE GRID DATASOURCE

        public ActionResult GetData()
        {
            
                
            return Json(new { result = model, count = model.Count() }, JsonRequestBehavior.AllowGet);
        }

        //PERFORM INSERT

        public ActionResult PerformInsert(string action, Person value)
        {
            int nextID = model.Max(p => p.ID) + 1;
                      
            model.Add(new Person() { ID = nextID, Name = value.Name, Surname = value.Surname});

            return Json(value, JsonRequestBehavior.AllowGet);

        }

        //PERFORM UPDATE

        public ActionResult PerformUpdate(int key, Person value)
        {

            Person toUpdate = model.Where(p => p.ID == key).FirstOrDefault();

            if (toUpdate != null)
            {
                toUpdate.Name = value.Name;
                toUpdate.Surname = value.Surname;
            }

            return Json(value, JsonRequestBehavior.AllowGet);

        }


        //PERFORM DELETE

        public ActionResult PerformDelete(int key)
        {
            Person toUpdate = model.Where(p => p.ID == key).FirstOrDefault();

            if (toUpdate != null)           
                model.Remove(toUpdate);

            return Json(key, JsonRequestBehavior.AllowGet);

        }

    }
    
}
