﻿using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Web;

namespace ProtoSF.Models
{
    public static class WholeModel
    {
        private static List<Person> _personDB = null;
        public static List<Person> PersonDB
        {
            get { return _personDB; }
        }

        private static List<Movie> _movieDB = null;
        public static List<Movie> MovieDB
        {
            get { return _movieDB; }
        }

        private static List<Interaction> _interactionDB = new List<Interaction>();
        public static List<Interaction> InteractionDB
        {
            get { return _interactionDB; }
        }


        static WholeModel()
        {
            _personDB = new List<Person>();
            List<Movie> movieBuffer;
            List<Actor> actorBuffer;

            int personId = 0;
            int movieId = 150;
            int actorID = 0;

            for (int i = 0; i < 5; i++)
            {
                Person personToAdd = new Person() { ID = personId++, Name = "Name" + i.ToString(), Surname = "Surname" + i.ToString() };

                movieBuffer = new List<Movie>();

                for (int j = 0; j < 4; j++)
                {
                    Movie movieToAdd = new Movie() { ID = movieId++, Title = "Movie" + i.ToString() + j.ToString(), Price = i * j };

                    actorBuffer = new List<Actor>();

                    for (int k = 0; k < 3; k++)
                    {
                        Actor actorToAdd = new Actor() { ID = actorID++, StageName = "Actor" + i.ToString() + j.ToString() + k.ToString(), Fee = i * j * k * 100 };
                        actorBuffer.Add(actorToAdd);
                    }

                    movieToAdd.Actors = actorBuffer;
                    movieBuffer.Add(movieToAdd);
                }

                //personToAdd.Movies = movieBuffer;
                _personDB.Add(personToAdd);
            }

            _movieDB = new List<Movie>();

            //foreach (Person person in _personDB)
            //{
            //    foreach (Movie movie in person.Movies)
            //    {
            //        if (_movieDB.Where(m => m.ID == movie.ID).Count() == 0)
            //            _movieDB.Add(movie);
            //    }
            //}
        }

        public static Movie getMovieByID(int ID)
        {
            return _movieDB.Where(m => m.ID == ID).FirstOrDefault();
        }

    }

    public class Person
    {
        public int ID { get; set; }
        public string Name { get; set; }
        public string Surname { get; set; }
        //public List<Movie> Movies { get; set; }

        //public void addMovieIfUnique(Movie toAdd)
        //{
        //    if (Movies.Where(m => m.ID == toAdd.ID).Count() == 0)
        //        Movies.Add(toAdd);
        //}
    }

    public class Movie
    {
        public int ID { get; set; }
        public string Title { get; set; }
        public int Price { get; set; }
        public List<Actor> Actors { get; set; }
    }

    public class Actor
    {
        public int ID { get; set; }
        public string StageName { get; set; }
        public int Fee { get; set; }
    }

    public class Interaction
    {
        public int ID { get; set; }
        public int Person_ID { get; set; }
        public DateTime Time { get; set; }
        public DateTime Date { get; set; }
        public bool Flag { get; set; }
        public Double Real { get; set; }
    }

}